'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Model = exports.InstanceOf = exports.ArrayOf = exports.default = undefined;

var _class = require('./class');

var _model = require('./model');

var _model2 = _interopRequireDefault(_model);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var adapter = function adapter() {
  var data = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
  var model = arguments[1];
  var memo = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];
  var parent = arguments.length <= 3 || arguments[3] === undefined ? false : arguments[3];

  var _type = model.getType();

  var list = (0, _utils.associativeTable)(data, function (current) {
    var element = model.getConverter()(current, parent);
    return {
      key: element.id,
      data: (0, _utils.mapObject)(element, function (value) {
        if (value instanceof _class.ArrayOf || value instanceof _class.InstanceOf) {
          adapter(value.getData(), value.getType(), memo, current);
          value = value.getConvertData();
        }
        return value;
      })
    };
  });

  if ((0, _utils.isObj)(memo[_type])) Object.assign(memo[_type], list);else memo[_type] = list;

  return memo;
};

exports.default = adapter;
exports.ArrayOf = _class.ArrayOf;
exports.InstanceOf = _class.InstanceOf;
exports.Model = _model2.default;